﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO.Ports;
using System.Collections;
using AsReaderP51N;
using System.Data;

namespace AsReaderP51N_Demo_Tool
{
    class Device
    {
        private static AsReader asreader = new AsReaderP51N.AsReader();
        public delegate void CallBackResultTagData(AsReader.InventoryResult data);
        public delegate void CallBackResultError(uint error);
        public static CallBackResultTagData callBackResultTagData = null;
        public static CallBackResultError callBackResultError = null;

        static Dictionary<Types.TargetType, string> dicTarget = new Dictionary<Types.TargetType, string>{
            { Types.TargetType.SESSION_S0, "SESSION_S0" },
            { Types.TargetType.SESSION_S1,"SESSION_S1" },
            { Types.TargetType.SESSION_S2,"SESSION_S2" },
            { Types.TargetType.SESSION_S3,"SESSION_S3" },
            { Types.TargetType.SL_FLAG,"SL_FLAG" },
        };
        static Dictionary<Types.ActionType, string> dicAction = new Dictionary<Types.ActionType, string>{
            { Types.ActionType.ACTION_ASLINVA_DSLINVB, "ASLINVA_DSLINVB" },
            { Types.ActionType.ACTION_ASLINVA_NOTHING,"ASLINVA_NOTHING" },
            { Types.ActionType.ACTION_DSLINVB_ASLINVA,"DSLINVB_ASLINVA" },
            { Types.ActionType.ACTION_DSLINVB_NOTHING,"DSLINVB_NOTHING" },
            { Types.ActionType.ACTION_NOTHING_ASLINVA,"NOTHING_ASLINVA" },
            { Types.ActionType.ACTION_NOTHING_DSLINVB,"NOTHING_DSLINVB" },
            { Types.ActionType.ACTION_NOTHING_NSLINVS,"NOTHING_NSLINVS" },
            { Types.ActionType.ACTION_NSLINVS_NOTHING,"NSLINVS_NOTHING" },
        };
        static Dictionary<Types.RfMode, string> dicRfMode = new Dictionary<Types.RfMode, string>{
            { Types.RfMode.RFMODE0,"0" },
            { Types.RfMode.RFMODE1,"1" },
            { Types.RfMode.RFMODE2,"2" },
            { Types.RfMode.RFMODE3,"3" },
            { Types.RfMode.RFMODE4,"4" },
        };
        static Dictionary<Types.SearchMode, string> dicSearchMode = new Dictionary<Types.SearchMode, string>{
            { Types.SearchMode.INVENTORY_SEARCH_MODE_AUTO_SEARCH, "AUTO_SEARCH" },
            { Types.SearchMode.INVENTORY_SEARCH_MODE_DUAL_TARGET,"DUAL_TARGET" },
            { Types.SearchMode.INVENTORY_SEARCH_MODE_SINGLE_TARGET_A_TO_B,"SINGLE_TARGET_A_TO_B" },
            { Types.SearchMode.INVENTORY_SEARCH_MODE_SINGLE_TARGET_B_TO_A,"SINGLE_TARGET_B_TO_A" },
        };

        static Dictionary<Types.SessionType, string> dicSession = new Dictionary<Types.SessionType, string>{
            { Types.SessionType.SESSION_S0,"0" },
            { Types.SessionType.SESSION_S1,"1" },
            { Types.SessionType.SESSION_S2,"2" },
            { Types.SessionType.SESSION_S3,"3" },
        };

        /// <summary>
        /// 
        /// </summary>
        /// <param name="info"></param>
        public static void GetDeviceInfo(ref AsReader.DeviceInformation info)
        {
            asreader.GetDeviceInformation(ref info);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="info"></param>
        public static void GetDeviceIPInformation(ref List<string> ipList)
        {
            asreader.GetDeviceIPInformation(ref ipList);
        }

        /// <summary>
        /// device connect
        /// </summary>
        /// <param name="comPort"></param>
        /// <returns></returns>
        public static UInt32 ConnectWithVcp(string comPort)
        {
            UInt32 ret = asreader.ConnectWithVCP(comPort);
            if (ret == 0) SetDelegate();
            return ret;
        }
        
        /// <summary>
         /// device connect(TCP)
         /// </summary>
         /// <param name="tcpIpAddress"></param>
         /// <param name="tcpPort"></param>
         /// <returns></returns>
        public static UInt32 ConnectWithTcp(string tcpIpAddress, string tcpPort)
        {
            UInt32 ret = asreader.ConnectWithTCP(tcpIpAddress, tcpPort);
            if (ret == 0) SetDelegate();
            return ret;
        }

        /// <summary>
        /// Device Disconnect
        /// </summary>
        public static UInt32 Disconnect() {
            return asreader.Disconnect();
        }

        public static UInt32 StartInventory(bool epc, bool tid, bool pc, bool rssi, bool phase, bool channel, bool ant)
        {
            return asreader.StartInventory(epc, tid, pc, rssi, phase, channel, ant);
        }

        public static UInt32 SetAntennaPorts(bool ant1, bool ant2, bool ant3, bool ant4)
        {
            return asreader.SetAntennaPorts(ant1, ant2, ant3, ant4);
        }

        public static UInt32 WriteMemory(Types.MemBankType membank, UInt32 offset, UInt32 password, byte[] epc, byte[] ren)
        {
            return asreader.WriteMemory(membank, offset, password, epc, ren);
        }

        public static UInt32 ReadMemory(Types.MemBankType membank, UInt32 offset, UInt32 length, UInt32 password, byte[] epc)
        {
            return asreader.ReadMemory(membank, offset, length, password, epc);
        }

        public static UInt32 SetSelectMask(Types.MemBankType membank, Types.TargetType target, Types.ActionType action, UInt32 selOffset, byte[] epc)
        {
            return asreader.SetSelectMask(membank, target, action, selOffset, epc);
        }

        public static UInt32 LockMemory(AsReader.TagMask tagMask, AsReader.TagAction tagAction, UInt32 accessPwd, byte[] epc)
        {
            return asreader.LockMemory(tagMask, tagAction, accessPwd, epc);
        }

        public static UInt32 Kill(UInt32 killPwd, byte[] epc) {
            return asreader.Kill(killPwd, epc);
        }

        public static UInt32 GetTxPower(ref UInt32 power) {
            return asreader.GetTxPower(ref power);
        }

        public static UInt32 GetAntennaPorts(ref bool ant1, ref bool ant2, ref bool ant3, ref bool ant4) {
            return asreader.GetAntennaPorts(ref ant1, ref ant2, ref ant3, ref ant4);
        }

        public static UInt32 SetRfMode(Types.RfMode rfMode)
        {
            return asreader.SetRfMode(rfMode);
        }

        public static UInt32 GetRfMode(ref Types.RfMode rfMode)
        {
            return asreader.GetRfMode(ref rfMode);
        }

        public static UInt32 SetSession(Types.SessionType session)
        {
            return asreader.SetSession(session);
        }

        public static UInt32 GetSession(ref Types.SessionType sessionType)
        {
            return asreader.GetSession(ref sessionType);
        }

        public static UInt32 SetSearchMode(Types.SearchMode searchMode)
        {
            return asreader.SetSearchMode(searchMode);
        }

        public static UInt32 GetSearchMode(ref Types.SearchMode searchMode)
        {
            return asreader.GetSearchMode(ref searchMode);
        }

        public static UInt32 GetFirmwareVersion(ref string firmwareVer)
        {
            return asreader.GetFirmwareVersion(ref firmwareVer);
        }

        public static UInt32 StopInventory() {
            return asreader.StopInventory();
        }

        public static UInt32 SetTxPower(UInt32 power)
        {
            return asreader.SetTxPower(power);
        }

        public static UInt32 SetRegion(Types.RegionType region)
        {
            return asreader.SetRegion(region);
        }

        public static UInt32 GetRegion(ref Types.RegionType region)
        {
            return asreader.GetRegion(ref region);
        }

        public static bool SetStaticIP(string ip,string subnet,string gateway,string dns)
        {
            return asreader.SetStaticIP(ip, subnet, gateway, dns);
        }

        public static void GetSdkVersion(ref string SdkVersion)
        {
            asreader.GetSdkVersion(ref SdkVersion);
        }
        public static uint GetAllKeys(ref ArrayList list)
        {
            return asreader.GetAllKeys(ref list);
        }
        public static uint SetupCustomRegion(uint[] channelTable)
        {
            return asreader.SetupCustomRegion(channelTable);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="delCallBackReadTagData"></param>
        /// <param name="delCallBackErrorString"></param>
        private static void SetDelegate()
        {
            AsReader.CallBackReadTagData delCallBackReadTagData = CallBackReadTagData;
            AsReader.CallBackErrorCode delCallBackErrorString = CallBackErrorString;
            asreader.SetDelegate(delCallBackReadTagData, delCallBackErrorString);
        }

        public static void CallBackReadTagData(AsReader.InventoryResult tagcallbackdata)
        {
            if (callBackResultTagData != null)
            {
                callBackResultTagData(tagcallbackdata);
            }
        }

        public static void CallBackErrorString(uint error)
        {
            if (callBackResultError != null)
            {
                callBackResultError(error);

            }
        }

        /// <summary>
        /// combox list
        /// </summary>
        public static DataTable getComboxList(Type type)
        {
            Array arrs = System.Enum.GetValues(type);    // 获取枚举的所有值
            DataTable dt = new DataTable();
            dt.Columns.Add("value", typeof(int));
            dt.Columns.Add("name", Type.GetType("System.String"));
            foreach (var arr in arrs)
            {
                string strText = Enum.Parse(type, arr.ToString()).ToString();
                DataRow aRow = dt.NewRow();
                aRow[0] = (int)arr;
                aRow[1] = strText;
                dt.Rows.Add(aRow);
            }
            return dt;
        }
    }
}
